## purify 2.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(Purify C CXX)

# Location of extra cmake includes for the project
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_files)

# Downloads and installs GreatCMakeCookOff
# It contains a number of cmake recipes
include(LookUp-GreatCMakeCookOff)

option(tests          "Enable testing"                                  on)
option(examples       "Compile examples"                                on)
option(data           "Download measurement set for testing"            on)
option(openmp         "Enable OpenMP"                                   on)
option(logging        "Enable logging"                                  on)

# Set version and build id of this package
include(version)

# we are doing c++11
include(AddCPP11Flags)

# sets up rpath so libraries can be found
include(rpath)

# adds logging variables
include(logging)

# include exernal dependencies
include(dependencies)
if(EXISTS "${EXTERNAL_ROOT}/lib/")
    install(DIRECTORY "${EXTERNAL_ROOT}/lib/"
        DESTINATION "${LIBRARY_INSTALL_PATH}"
        PATTERN "pkgconfig" EXCLUDE
        PATTERN "*.a" EXCLUDE
    )
endif()

if(tests AND data)
    include(data_dependencies)
endif()

if(tests)  # Adds ctest
    enable_testing()
    include(AddCatchTest)
endif()

add_subdirectory(cpp)

# Exports Purify so other packages can access it
include(export_purify)

=== cpp/CMakeLists.txt ===
# adds include dirs which are located within the build directory
# That is, whathever package is downloaded automatically by the build system
# This complication arises because cmake won't install targets with headers that point to the build
# dir.
# Users will have to install packages globally for all the right headers to be found
function(add_include_dir)
  unset(privates)
  foreach(dir ${ARGN})
    file(RELATIVE_PATH rel "${PROJECT_BINARY_DIR}" "${dir}" )
    if(NOT "${rel}" MATCHES "^\\.\\./")
      list(APPEND privates "${dir}")
    endif()
  endforeach() 
  if(privates)
    include_directories(SYSTEM ${privates})
  endif()
endfunction()

add_include_dir(
  ${EIGEN3_INCLUDE_DIR}
  ${Boost_INCLUDE_DIR}
  ${CFitsIO_INCLUDE_DIR}
  ${CCFits_INCLUDE_DIR}/..
)

add_subdirectory(purify)
if(tests OR examples)
  configure_file(tests/directories.in.h "${PROJECT_BINARY_DIR}/include/purify/directories.h")
endif()
if(examples)
  add_subdirectory(example)
endif()
if(tests)
  add_subdirectory(tests)
endif()

if(TARGET casacore::ms)
  add_executable(purify main.cc cmdl.cc AlgorithmUpdate.cc)
  target_link_libraries(purify libpurify)
  set_target_properties(purify PROPERTIES OUTPUT_NAME ${PROJECT_BINARY_DIR}/purify)

  install(TARGETS purify
    EXPORT PurifyTargets
    DESTINATION share/cmake/Purify
    RUNTIME DESTINATION bin
  )
endif()

=== cpp/example/CMakeLists.txt ===
include(AddExample)

include_directorieS(SYSTEM ${Sopt_INCLUDE_DIRS})
include_directories("${PROJECT_SOURCE_DIR}/cpp")

add_example(gridding LIBRARIES libpurify)
add_example(rm_gridding_example LIBRARIES libpurify NOTEST)
add_example(generate_vis_data LIBRARIES libpurify NOTEST)

add_example(time_gridding_degridding LIBRARIES libpurify NOTEST)

add_example(sdmm_random_coverage LIBRARIES libpurify NOTEST)
add_example(sdmm_vla LIBRARIES libpurify NOTEST)

add_example(resample LIBRARIES libpurify)

add_example(sdmm_m31_simulation LIBRARIES libpurify NOTEST)

add_example(padmm_simulation LIBRARIES libpurify NOTEST)
add_example(padmm_reweighted_simulation LIBRARIES libpurify NOTEST)

add_example(padmm_random_coverage LIBRARIES libpurify NOTEST)

add_example(sara_padmm_random_coverage LIBRARIES libpurify NOTEST)

add_example(clean_vla LIBRARIES libpurify NOTEST)

if(data AND TARGET casacore::ms)
  add_example(casa LIBRARIES libpurify)
endif()

=== cpp/purify/CMakeLists.txt ===
# Add to install includes only if outside build dir
function(add_include_dir)
  unset(publics)
  unset(privates)
  foreach(dir ${ARGN})
    file(RELATIVE_PATH rel "${PROJECT_BINARY_DIR}" "${dir}" )
    if("${rel}" MATCHES "^\\.\\./")
      list(APPEND publics "${dir}")
    endif()
  endforeach() 
  if(public)
    target_include_directories(libpurify SYSTEM PUBLIC ${publics})
  endif()
endfunction()



configure_file(config.in.h "${PROJECT_BINARY_DIR}/include/purify/config.h")

set(HEADERS 
  RMOperator.h logging.h FFTOperator.h kernels.h
  pfitsio.h MeasurementOperator.h clean.h logging.disabled.h types.h PSFOperator.h
  logging.enabled.h utilities.h "${PROJECT_BINARY_DIR}/include/purify/config.h")

set(SOURCES MeasurementOperator.cc FFTOperator.cc clean.cc utilities.cc pfitsio.cc
  kernels.cc RMOperator.cc PSFOperator.cc)

if(TARGET casacore::ms)
  list(APPEND SOURCES casacore.cc)
  list(APPEND HEADERS casacore.h)
endif()
add_library(libpurify SHARED ${SOURCES})
set(version "${Purify_VERSION_MAJOR}.${Purify_VERSION_MINOR}.${Purify_VERSION_PATCH}")
set_target_properties(libpurify PROPERTIES VERSION ${version} SOVERSION ${version})

target_include_directories(libpurify PUBLIC
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/cpp>
  $<INSTALL_INTERFACE:include/>)


add_include_dir(
  ${EIGEN3_INCLUDE_DIR}
  ${Boost_INCLUDE_DIR}
  ${CFitsIO_INCLUDE_DIR}
  ${CCFits_INCLUDE_DIR}/..
)
target_link_libraries(libpurify
  ${FFTW3_DOUBLE_LIBRARY} ${CCFits_LIBRARY} ${CFitsIO_LIBRARY} ${Sopt_CPP_LIBRARY})
if(TARGET casacore::casa)
  target_link_libraries(libpurify casacore::ms)
endif()
if(TARGET openmp::openmp)
  target_link_libraries(libpurify openmp::openmp)
endif()

add_dependencies(libpurify lookup_dependencies)

install(FILES ${HEADERS} DESTINATION include/purify)
install(TARGETS libpurify
  EXPORT PurifyTargets
  DESTINATION share/cmake/Purify
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  INCLUDES DESTINATION include
)

=== cpp/tests/CMakeLists.txt ===
include_directories("${PROJECT_SOURCE_DIR}/cpp" "${CMAKE_CURRENT_BINARY_DIR}/include/purify")
file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/outputs")
add_catch_test(measurement_operator LIBRARIES libpurify)
add_catch_test(FFT_operator LIBRARIES libpurify)
add_catch_test(purify_fitsio LIBRARIES libpurify)
add_catch_test(utils LIBRARIES libpurify)
add_catch_test(sparse LIBRARIES libpurify)
if(data AND TARGET casacore::ms)
  add_catch_test(casacore LIBRARIES libpurify ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
endif()

=== debian/changelog ===
purify (2.0.0-6) unstable; urgency=medium

  * Team Upload.
  * Use DEB_HOST_MULTIARCH instead of DEB_BUILD_MULTIARCH
    (Closes: #985103)
  * Add "Rules-Requires-Root: no"
  * d/rules: Propagate hardening options
  * Bump watch version to 4

 -- Nilesh Patra <nilesh@debian.org>  Sun, 15 Aug 2021 14:40:39 +0530

purify (2.0.0-5) unstable; urgency=medium

  * Update github organization name
  * Push Standards-Version to 4.5.0. No changes needed
  * Push compat to 13. Remove d/compat
  * Define SPDLOG_FMT_EXTERNAL to work aound #956694

 -- Ole Streicher <olebole@debian.org>  Sun, 17 May 2020 20:21:27 +0200

purify (2.0.0-4) unstable; urgency=medium

  * Disable measurement_operator test on aarch64 (Closes: #867273)

 -- Ole Streicher <olebole@debian.org>  Fri, 12 Oct 2018 17:22:28 +0200

purify (2.0.0-3) unstable; urgency=medium

  * Update VCS fields to use salsa.d.o
  * Add spdlog header (Closes: #909765)
  * Push Standards-Version to 4.2.1. No changes needed
  * Push compat to 11

 -- Ole Streicher <olebole@debian.org>  Sun, 30 Sep 2018 10:48:51 +0200

purify (2.0.0-2) unstable; urgency=medium

  [ Andreas Tille ]
  * URL should be a link to the publishers site (if possible)
  * Full bibtex compatible authors list
  * Publisher provides PDF to point there which is considered more safe
    than private homepages that might vanish randomly

  [ Ole Streicher ]
  * spdlog modified API (Closes: #884214)
  * Push Standards-Version to 4.1.2. Use https in all urls

 -- Ole Streicher <olebole@debian.org>  Tue, 12 Dec 2017 21:07:05 +0100

purify (2.0.0-1) unstable; urgency=low

  * New package. Closes: #830126

 -- Ole Streicher <olebole@debian.org>  Tue, 18 Oct 2016 11:33:14 +0200

=== debian/control ===
Source: purify
Section: science
Priority: optional
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Gijs Molenaar <gijs@pythonic.nl>, Ole Streicher <olebole@debian.org>
Build-Depends: casacore-dev,
               catch,
               cmake,
               debhelper-compat (= 13),
               libblas-dev,
               libboost-dev,
               libccfits-dev,
               libeigen3-dev,
               libfftw3-dev,
               libsopt-dev,
               libspdlog-dev,
               libtiff5-dev
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/debian-astro-team/purify.git
Vcs-Browser: https://salsa.debian.org/debian-astro-team/purify
Homepage: https://astro-informatics.github.io/purify/
Rules-Requires-Root: no

Package: purify
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libpurify-dev
Description: Collection of routines for radio interferometric imaging
 PURIFY is a collection of routines written in C that implements different
 tools for radio interferometric imaging including file handling (for both
 visibilities and fits files), implementation of the measurement operator
 and set-up of the different optimization problems used for image
 deconvolution. The code calls the generic Sparse OPTimization (SOPT)
 package to solve the imaging optimization problems.

Package: libpurify2.0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Routines for radio interferometric imaging (shared lib)
 PURIFY is a collection of routines written in C that implements different
 tools for radio interferometric imaging including file handling (for both
 visibilities and fits files), implementation of the measurement operator
 and set-up of the different optimization problems used for image
 deconvolution. The code calls the generic Sparse OPTimization (SOPT)
 package to solve the imaging optimization problems.
 .
 This package contains the shared library.

Package: libpurify-dev
Architecture: any
Section: libdevel
Depends: libpurify2.0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: purify
Description: Routines for radio interferometric imaging (development files)
 PURIFY is a collection of routines written in C that implements different
 tools for radio interferometric imaging including file handling (for both
 visibilities and fits files), implementation of the measurement operator
 and set-up of the different optimization problems used for image
 deconvolution. The code calls the generic Sparse OPTimization (SOPT)
 package to solve the imaging optimization problems.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
CMAKE_FLAGS += -DDEB_HOST_MULTIARCH=`dpkg-architecture -qDEB_HOST_MULTIARCH`

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	cp -r /usr/include/eigen3 .
	cd eigen3 && patch -p1 < ../debian/eigen3_LukePratley.patch
	dh_auto_configure -- $(CMAKE_FLAGS)

## purify 4.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)
project(Purify C CXX)

# Location of extra cmake includes for the project
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_files)
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/build)

option(tests          "Enable testing"                                  on)
option(examples       "Compile examples"                                off)
option(benchmarks     "Enable benchmarking"                             off)
option(openmp         "Enable OpenMP"                                   on)
option(dompi          "Enable MPI"                                      on)
option(doaf           "Enable ArrayFire"                                off)
option(docimg         "Enable CImg"                                     off)
option(docasa         "Enable CASA"                                     off)
option(docs           "Build documentation"                             off)
option(coverage       "Build coverage"                                  off)
option(cppflow        "Build with TensorFlow interface"                 off)

if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build Type" FORCE)
endif()
message(STATUS "Building purify in ${CMAKE_BUILD_TYPE} mode")

# Set version and build id of this package
include(version)
set(Sopt_GIT_TAG "development" CACHE STRING "Branch/tag when downloading sopt")

## we are doing c++11
#include(AddCPP11Flags)
# c++17 is required when using cppflow with learned algorithms
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# sets up rpath so libraries can be found
include(rpath)

# include exernal dependencies
include(dependencies)

set(PURIFY_TEST_LOG_LEVEL critical CACHE STRING "Level when logging tests")
set_property(CACHE PURIFY_TEST_LOG_LEVEL
             PROPERTY STRINGS off critical error warn info debug trace)

# If PURIFY_OPENMP is set to False in dependencies, link libpthread here so that the linker finds it
# Following advice from https://stackoverflow.com/questions/1620918/cmake-and-libpthread
if(NOT PURIFY_OPENMP)
  set(CMAKE_THREAD_LIBS_INIT "-lpthread")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
endif()

if(tests)  # Adds ctest
  enable_testing()
  find_package(Catch2)
  include(AddCatchTest)
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument")

if(tests AND coverage)
  # Enable code coverage.
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
	# Build with debugging information to make the output meaningful.
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
	# Disable optimizations to get the most accurate results.
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
endif()

if(benchmarks)
  set(GBenchmark_GIT_TAG "v1.3.0")
  include(AddBenchmark)
endif()

add_subdirectory(cpp)


# Exports Purify so other packages can access it
include(export_purify)

=== cpp/benchmarks/CMakeLists.txt ===
include_directories("${PROJECT_SOURCE_DIR}/cpp" "${CMAKE_CURRENT_BINARY_DIR}/include")

add_benchmark(measurement_operator utilities.cc LIBRARIES libpurify)
add_benchmark(padmm utilities.cc LIBRARIES libpurify)
add_benchmark(wavelet_operator utilities.cc LIBRARIES libpurify)
add_benchmark(fft utilities.cc LIBRARIES libpurify)
add_benchmark(degridding utilities.cc LIBRARIES libpurify)
if(doaf)
  add_benchmark(measurement_operator_af utilities.cc LIBRARIES libpurify)
  add_benchmark(measurement_operator_cpu measurement_operator_af.cc utilities.cc LIBRARIES libpurify)
  target_compile_definitions(benchmark_measurement_operator_cpu PRIVATE PURIFY_CPU)
endif()

if(dompi)
  add_executable(mpi_benchmark_MO main.cc utilities.cc measurement_operator_mpi.cc)
  target_link_libraries(mpi_benchmark_MO ${MPI_LIBRARIES} gbenchmark libpurify)
  target_include_directories(mpi_benchmark_MO PUBLIC "${PROJECT_SOURCE_DIR}/cpp" "${CMAKE_CURRENT_BINARY_DIR}/include")
  add_executable(mpi_benchmark_MO_wproj main.cc utilities.cc measurement_operator_wproj.cc)
  target_link_libraries(mpi_benchmark_MO_wproj ${MPI_LIBRARIES} gbenchmark libpurify)
  target_include_directories(mpi_benchmark_MO_wproj PUBLIC "${PROJECT_SOURCE_DIR}/cpp" "${CMAKE_CURRENT_BINARY_DIR}/include")
  add_executable(mpi_benchmark_PADMM main.cc utilities.cc padmm_mpi.cc)
  target_link_libraries(mpi_benchmark_PADMM ${MPI_LIBRARIES} gbenchmark libpurify)
  target_include_directories(mpi_benchmark_PADMM PUBLIC "${PROJECT_SOURCE_DIR}/cpp" "${CMAKE_CURRENT_BINARY_DIR}/include")
  add_executable(mpi_benchmark_WLO main.cc utilities.cc wavelet_operator_mpi.cc)
  target_link_libraries(mpi_benchmark_WLO ${MPI_LIBRARIES} gbenchmark libpurify)
  target_include_directories(mpi_benchmark_WLO PUBLIC "${PROJECT_SOURCE_DIR}/cpp" "${CMAKE_CURRENT_BINARY_DIR}/include")
endif()

=== cpp/purify/CMakeLists.txt ===
# Add to install includes only if outside build dir
function(add_include_dir)
  unset(publics)
  unset(privates)
  foreach(dir ${ARGN})
    file(RELATIVE_PATH rel "${PROJECT_BINARY_DIR}" "${dir}" )
    if("${rel}" MATCHES "^\\.\\./")
      list(APPEND publics "${dir}")
    endif()
  endforeach()
  if(publics)
    target_include_directories(libpurify SYSTEM PUBLIC ${publics})
  endif()
endfunction()

configure_file(config.in.h "${PROJECT_BINARY_DIR}/include/purify/config.h")

set(HEADERS
  logging.h kernels.h pfitsio.h  types.h
  IndexMapping.h utilities.h operators.h  wproj_utilities.h
  cimg.h uvfits.h convolution.h measurement_operator_factory.h wavelet_operator_factory.h distribute.h
  update_factory.h
  convergence_factory.h
  algorithm_factory.h
  read_measurements.h
  yaml-parser.h
  integration.h
  wide_field_utilities.h
  wkernel_integration.h
  wproj_operators.h
  uvw_utilities.h
  fly_operators.h
  "${PROJECT_BINARY_DIR}/include/purify/config.h")

set(SOURCES utilities.cc pfitsio.cc logging.cc
  kernels.cc wproj_utilities.cc operators.cc uvfits.cc yaml-parser.cc
  read_measurements.cc distribute.cc integration.cc wide_field_utilities.cc wkernel_integration.cc
  wproj_operators.cc uvw_utilities.cc)

if(PURIFY_CASACORE)
  list(APPEND SOURCES casacore.cc)
  list(APPEND HEADERS casacore.h)
endif()

if(PURIFY_MPI)
  list(APPEND HEADERS mpi_utilities.h distribute.h DistributeSparseVector.h
  random_update_factory.h
  AllToAllSparseVector.h)
  list(APPEND SOURCES mpi_utilities.cc distribute.cc AllToAllSparseVector.cc
  random_update_factory.cc)
endif()

add_library(libpurify SHARED ${SOURCES})
set(version "${Purify_VERSION_MAJOR}.${Purify_VERSION_MINOR}.${Purify_VERSION_PATCH}")
set(soversion "${Purify_VERSION_MAJOR}.${Purify_VERSION_MINOR}")
set_target_properties(libpurify PROPERTIES VERSION ${version} SOVERSION ${soversion})
set_target_properties(libpurify PROPERTIES OUTPUT_NAME purify)

if(PURIFY_OPENMP)
  target_link_libraries(libpurify OpenMP::OpenMP_CXX)
endif()

if(PURIFY_MPI)
  target_link_libraries(libpurify ${MPI_LIBRARIES})
  target_include_directories(libpurify SYSTEM PUBLIC ${MPI_CXX_INCLUDE_PATH})
endif()

if(PURIFY_ARRAYFIRE)
  list(APPEND HEADERS operators_gpu.h wproj_operators_gpu.h)
  target_link_libraries(libpurify ${ArrayFire_LIBRARIES})
endif()

target_include_directories(libpurify PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:include/>)

if (cppflow)
  target_link_libraries(libpurify "${TENSORFLOW_LIB}")
  # Make cppflow include directory public. Install interface can't point to source directory,
  # so it needs to be separately defined, explained in
  # https://stackoverflow.com/questions/25676277/cmake-target-include-directories-prints-an-error-when-i-try-to-add-the-source
  # Add /usr/local/include for default location of TensorFlow headers
  target_include_directories(libpurify PUBLIC
    $<BUILD_INTERFACE:${cppflow_INCLUDE_DIR}>
    $<BUILD_INTERFACE:/usr/local/include>
    $<INSTALL_INTERFACE:cppflow/include/>
  )
endif()

add_include_dir(
  ${EIGEN3_INCLUDE_DIR}
  ${Boost_INCLUDE_DIR}
  ${cfitsio_INCLUDE_DIR}
  ${FFTW3_INCLUDE_DIRS}
  ${YAML_CPP_INCLUDE_DIR}
  ${Cubature_INCLUDE_DIR}
  ${CImg_INCLUDE_DIR}
)

target_link_libraries(libpurify
  ${Cubature_LIBRARIES}
  ${FFTW3_LIBRARIES}
  cfitsio
  ${sopt_LIBRARIES}
  yaml-cpp
  Boost::filesystem
  Boost::system
)

if(PURIFY_CASACORE)
  target_link_libraries(libpurify ${CasaCore_LIBRARIES})
endif()

if(TARGET openmp::openmp)
  target_link_libraries(libpurify openmp::openmp)
endif()

if(PURIFY_CUBATURE_LOOKUP)
  add_dependencies(libpurify Lookup-Cubature)
endif()

if(PURIFY_CASACORE_LOOKUP)
  add_dependencies(libpurify Lookup-CasaCore)
endif()

# Add spdlog as direct dependency
if(spdlog_FOUND)
  target_link_libraries(libpurify spdlog::spdlog)
  target_include_directories(libpurify SYSTEM PUBLIC ${spdlog_INCLUDE_DIR})
endif()

install(FILES ${HEADERS} DESTINATION include/purify)
install(TARGETS libpurify
  EXPORT PurifyTargets
  DESTINATION share/cmake/Purify
  RUNTIME DESTINATION bin
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  INCLUDES DESTINATION include
)

=== cpp/tests/CMakeLists.txt ===

include_directories("${PROJECT_SOURCE_DIR}/cpp" "${PROJECT_BINARY_DIR}/include")
add_library(common_catch_main_object OBJECT "common_catch_main.cc")
if(spdlog_FOUND)
  target_link_libraries(common_catch_main_object spdlog::spdlog)
endif()
if(Catch2_FOUND)
  target_link_libraries(common_catch_main_object Catch2::Catch2)
endif()
if(EIGEN3_INCLUDE_DIR)
target_include_directories(common_catch_main_object SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIR})
endif()
if(sopt_FOUND)
  target_include_directories(common_catch_main_object SYSTEM PUBLIC ${sopt_INCLUDE_DIR})
endif()
target_include_directories(common_catch_main_object PUBLIC
  "${EXTERNAL_ROOT}/include/"
  "${PROJECT_BINARY_DIR}/include/"
)
file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/outputs")


add_catch_test(algo_factory LIBRARIES libpurify)
add_catch_test(convolution LIBRARIES libpurify)
add_catch_test(distribute LIBRARIES libpurify)
add_catch_test(index_mapping LIBRARIES libpurify)
add_catch_test(integration LIBRARIES libpurify)
add_catch_test(measurement_factory LIBRARIES libpurify)
add_catch_test(measurement_operator LIBRARIES libpurify)
add_catch_test(operators LIBRARIES libpurify)
add_catch_test(parser_test LIBRARIES libpurify)
add_catch_test(purify_fitsio LIBRARIES libpurify)
add_catch_test(read_measurements LIBRARIES libpurify)
add_catch_test(sparse LIBRARIES libpurify)
add_catch_test(utils LIBRARIES libpurify)
add_catch_test(uvfits LIBRARIES libpurify)
add_catch_test(wavelet_factory LIBRARIES libpurify)
add_catch_test(wide_field_utilities LIBRARIES libpurify)
add_catch_test(wkernel LIBRARIES libpurify)

if(PURIFY_CASACORE)
  add_catch_test(casacore LIBRARIES libpurify ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY} DEPENDS lookup_dependencies)
endif()

if(PURIFY_ARRAYFIRE)
  include_directories(${ArrayFire_INCLUDE_DIRS})
  add_catch_test(operators_gpu LIBRARIES libpurify ${ArrayFire_LIBRARIES})
endif()

if(PURIFY_MPI)
  add_library(common_mpi_catch_main_object OBJECT "common_mpi_catch_main.cc")
  target_include_directories(common_mpi_catch_main_object
    PUBLIC ${PROJECT_BINARY_DIR}/include ${MPI_CXX_INCLUDE_PATH})
  if(spdlog_FOUND)
    target_link_libraries(common_mpi_catch_main_object spdlog::spdlog)
  endif()
  if(Catch2_FOUND)
    target_link_libraries(common_mpi_catch_main_object Catch2::Catch2)
  endif()
  if(sopt_FOUND)
    target_include_directories(common_mpi_catch_main_object SYSTEM PUBLIC ${sopt_INCLUDE_DIR})
  endif()
  if(EIGEN3_INCLUDE_DIR)
    target_include_directories(common_mpi_catch_main_object SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIR})
  endif()

  function(add_mpi_test testname)
    add_catch_test(${testname} COMMON_MAIN common_mpi_catch_main_object NOTEST ${ARGN})
    unset(arguments)
    if(CATCH_JUNIT)
      set(arguments -r junit -o ${PROJECT_BINARY_DIR}/Testing/${testname}.xml)
    endif()
    if(NOT MPIEXEC_MAX_NUMPROCS)
      set(MPIEXEC_MAX_NUMPROCS 4)
    endif()
    add_test(NAME ${testname}
      COMMAND
      ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} ${MPIEXEC_MAX_NUMPROCS} ${MPIEXEC_PREFLAGS}
      $<TARGET_FILE:test_${testname}> ${arguments})
    set_tests_properties(${testname} PROPERTIES LABELS "catch;mpi")
  endfunction()

  add_mpi_test(distribute_sparse_vector LIBRARIES libpurify)
  add_mpi_test(kmeans LIBRARIES libpurify)
  add_mpi_test(mpi_algo_factory LIBRARIES libpurify)
  add_mpi_test(mpi_measurement_factory LIBRARIES libpurify)
  add_mpi_test(mpi_measurement_operator LIBRARIES libpurify)
  add_mpi_test(mpi_read_measurements LIBRARIES libpurify)
  add_catch_test(mpi_utilities LIBRARIES libpurify)
  add_mpi_test(mpi_wavelet_factory LIBRARIES libpurify)
  add_mpi_test(mpi_wide_field_utilities LIBRARIES libpurify)
  add_mpi_test(parallel_mpi_utilities LIBRARIES libpurify)
endif()

=== debian/changelog ===
purify (4.1.0-1) unstable; urgency=medium

  * New upstream version 4.1.0
  * Drop almost all patches: superceded upstream
  * Push Standards-Version to 4.7.0. No changes needed
  * Remove unused copyright statements
  * Disable search for fftw3
  * Update build dependencies
  * Add missing cstdint header
  * Remove local eigen3 implementation. Closes: #1001528
  * Disable long-running tests
  * Add gitlab-ci.yml
  * Limit build architectures to 64 bit

 -- Ole Streicher <olebole@debian.org>  Thu, 12 Sep 2024 14:36:53 +0200

=== debian/control ===
--- 
+++ 
@@ -3,19 +3,23 @@
 Priority: optional
 Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
 Uploaders: Gijs Molenaar <gijs@pythonic.nl>, Ole Streicher <olebole@debian.org>
-Build-Depends: casacore-dev,
+Build-Depends: architecture-is-64-bit,
+               casacore-dev,
                catch,
                cmake,
                debhelper-compat (= 13),
                libblas-dev,
                libboost-dev,
+               libboost-filesystem-dev,
                libccfits-dev,
+               libcubature-dev,
                libeigen3-dev,
                libfftw3-dev,
-               libsopt-dev,
+               libsopt-dev (>= 4.1.0~),
                libspdlog-dev,
-               libtiff5-dev
-Standards-Version: 4.5.0
+               libtiff5-dev,
+               libyaml-cpp-dev
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/debian-astro-team/purify.git
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/purify
 Homepage: https://astro-informatics.github.io/purify/

## purify 4.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 option(docasa         "Enable CASA"                                     off)
 option(docs           "Build documentation"                             off)
 option(coverage       "Build coverage"                                  off)
-option(cppflow        "Build with TensorFlow interface"                 off)
+option(onnxrt         "Build with ONNXruntime interface"                off)
 
 if(NOT CMAKE_BUILD_TYPE)
   message(STATUS "Setting build type to 'Release' as none was specified.")
@@ -29,7 +29,6 @@
 
 ## we are doing c++11
 #include(AddCPP11Flags)
-# c++17 is required when using cppflow with learned algorithms
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
@@ -51,26 +50,15 @@
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pthread")
 endif()
 
-if(tests)  # Adds ctest
-  enable_testing()
-  find_package(Catch2)
-  include(AddCatchTest)
-endif()
-
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument")
 
 if(tests AND coverage)
   # Enable code coverage.
-	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
-	# Build with debugging information to make the output meaningful.
-	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
-	# Disable optimizations to get the most accurate results.
-	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
-endif()
-
-if(benchmarks)
-  set(GBenchmark_GIT_TAG "v1.3.0")
-  include(AddBenchmark)
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
+  # Build with debugging information to make the output meaningful.
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
+  # Disable optimizations to get the most accurate results.
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
 endif()
 
 add_subdirectory(cpp)

=== cpp/CMakeLists.txt ===
# adds include dirs which are located within the build directory
# That is, whathever package is downloaded automatically by the build system
# This complication arises because cmake won't install targets with headers that point to the build
# dir.
# Users will have to install packages globally for all the right headers to be found
function(add_include_dir)
  unset(privates)
  foreach(dir ${ARGN})
    file(RELATIVE_PATH rel "${PROJECT_BINARY_DIR}" "${dir}" )
    if(NOT "${rel}" MATCHES "^\\.\\./")
      list(APPEND privates "${dir}")
    endif()
  endforeach()
  if(privates)
    include_directories(SYSTEM ${privates})
  endif()
endfunction()

add_include_dir(
  ${EIGEN3_INCLUDE_DIR}
  ${Boost_INCLUDE_DIR}
  ${cfitsio_INCLUDE_DIR}
  ${yaml-cpp_INCLUDE_DIR}
  ${Cubature_INCLUDE_DIR}
  ${CImg_INCLUDE_DIR}
)


link_directories(${FFTW3_LIBRARY_DIRS} ${YAML_CPP_LIBRARY_DIR} ${Cubature_LIBRARY_DIR})
add_subdirectory(purify)
if(tests OR examples OR benchmarks)
  configure_file(tests/directories.in.h "${PROJECT_BINARY_DIR}/include/purify/directories.h")
endif()
if(examples)
  add_subdirectory(example)
endif()
if(tests)
  configure_file(tests/data.in.h "${PROJECT_BINARY_DIR}/include/purify/test_data.h")
  add_subdirectory(tests)
endif()
if(benchmarks)
  add_subdirectory(benchmarks)
endif()
if (docs)
  add_subdirectory(docs)
endif()

add_executable(purify main.cc)
set_target_properties(purify PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
target_link_libraries(purify libpurify ${sopt_LIBRARIES})

install(TARGETS purify
  EXPORT PurifyTargets
  DESTINATION share/cmake/Purify
  RUNTIME DESTINATION bin
)

=== cpp/benchmarks/CMakeLists.txt ===
include_directories("${PROJECT_SOURCE_DIR}/cpp" "${CMAKE_CURRENT_BINARY_DIR}/include")

add_executable(measurement_operator utilities.cc measurement_operator.cc)
target_link_libraries(measurement_operator benchmark libpurify)
add_executable(padmm utilities.cc padmm.cc)
target_link_libraries(padmm benchmark libpurify)
add_executable(wavelet_operator utilities.cc wavelet_operator.cc)
target_link_libraries(wavelet_operator benchmark libpurify)
add_executable(fft utilities.cc fft.cc)
target_link_libraries(fft benchmark libpurify)
add_executable(degridding utilities.cc degridding.cc)
target_link_libraries(degridding benchmark libpurify)

# Skip ArrayFire benchmarks for now, add back later if needed
# if(doaf)
#   add_benchmark(measurement_operator_af utilities.cc LIBRARIES libpurify)
#   add_benchmark(measurement_operator_cpu measurement_operator_af.cc utilities.cc LIBRARIES libpurify)
#   target_compile_definitions(benchmark_measurement_operator_cpu PRIVATE PURIFY_CPU)
# endif()

if(dompi)
  add_executable(mpi_benchmark_MO main.cc utilities.cc measurement_operator_mpi.cc)
  target_link_libraries(mpi_benchmark_MO ${MPI_LIBRARIES} benchmark libpurify)
  #target_include_directories(mpi_benchmark_MO PUBLIC "${PROJECT_SOURCE_DIR}/cpp" "${CMAKE_CURRENT_BINARY_DIR}/include")
  add_executable(mpi_benchmark_MO_wproj main.cc utilities.cc measurement_operator_wproj.cc)
  target_link_libraries(mpi_benchmark_MO_wproj ${MPI_LIBRARIES} benchmark libpurify)
  #target_include_directories(mpi_benchmark_MO_wproj PUBLIC "${PROJECT_SOURCE_DIR}/cpp" "${CMAKE_CURRENT_BINARY_DIR}/include")
  add_executable(mpi_benchmark_PADMM main.cc utilities.cc padmm_mpi.cc)
  target_link_libraries(mpi_benchmark_PADMM ${MPI_LIBRARIES} benchmark libpurify)
  #target_include_directories(mpi_benchmark_PADMM PUBLIC "${PROJECT_SOURCE_DIR}/cpp" "${CMAKE_CURRENT_BINARY_DIR}/include")
  add_executable(mpi_benchmark_WLO main.cc utilities.cc wavelet_operator_mpi.cc)
  target_link_libraries(mpi_benchmark_WLO ${MPI_LIBRARIES} benchmark libpurify)
  #target_include_directories(mpi_benchmark_WLO PUBLIC "${PROJECT_SOURCE_DIR}/cpp" "${CMAKE_CURRENT_BINARY_DIR}/include")
endif()

=== cpp/purify/CMakeLists.txt ===
--- 
+++ 
@@ -75,19 +75,6 @@
   $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
   $<INSTALL_INTERFACE:include/>)
 
-if (cppflow)
-  target_link_libraries(libpurify "${TENSORFLOW_LIB}")
-  # Make cppflow include directory public. Install interface can't point to source directory,
-  # so it needs to be separately defined, explained in
-  # https://stackoverflow.com/questions/25676277/cmake-target-include-directories-prints-an-error-when-i-try-to-add-the-source
-  # Add /usr/local/include for default location of TensorFlow headers
-  target_include_directories(libpurify PUBLIC
-    $<BUILD_INTERFACE:${cppflow_INCLUDE_DIR}>
-    $<BUILD_INTERFACE:/usr/local/include>
-    $<INSTALL_INTERFACE:cppflow/include/>
-  )
-endif()
-
 add_include_dir(
   ${EIGEN3_INCLUDE_DIR}
   ${Boost_INCLUDE_DIR}
@@ -124,12 +111,6 @@
   add_dependencies(libpurify Lookup-CasaCore)
 endif()
 
-# Add spdlog as direct dependency
-if(spdlog_FOUND)
-  target_link_libraries(libpurify spdlog::spdlog)
-  target_include_directories(libpurify SYSTEM PUBLIC ${spdlog_INCLUDE_DIR})
-endif()
-
 install(FILES ${HEADERS} DESTINATION include/purify)
 install(TARGETS libpurify
   EXPORT PurifyTargets

=== cpp/tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,6 @@
 
 include_directories("${PROJECT_SOURCE_DIR}/cpp" "${PROJECT_BINARY_DIR}/include")
 add_library(common_catch_main_object OBJECT "common_catch_main.cc")
-if(spdlog_FOUND)
-  target_link_libraries(common_catch_main_object spdlog::spdlog)
-endif()
 if(Catch2_FOUND)
   target_link_libraries(common_catch_main_object Catch2::Catch2)
 endif()
@@ -51,9 +48,6 @@
   add_library(common_mpi_catch_main_object OBJECT "common_mpi_catch_main.cc")
   target_include_directories(common_mpi_catch_main_object
     PUBLIC ${PROJECT_BINARY_DIR}/include ${MPI_CXX_INCLUDE_PATH})
-  if(spdlog_FOUND)
-    target_link_libraries(common_mpi_catch_main_object spdlog::spdlog)
-  endif()
   if(Catch2_FOUND)
     target_link_libraries(common_mpi_catch_main_object Catch2::Catch2)
   endif()
@@ -76,7 +70,7 @@
     add_test(NAME ${testname}
       COMMAND
       ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} ${MPIEXEC_MAX_NUMPROCS} ${MPIEXEC_PREFLAGS}
-      $<TARGET_FILE:test_${testname}> ${arguments})
+      "./test_${testname}" ${arguments})
     set_tests_properties(${testname} PROPERTIES LABELS "catch;mpi")
   endfunction()
 
@@ -91,3 +85,6 @@
   add_mpi_test(mpi_wide_field_utilities LIBRARIES libpurify)
   add_mpi_test(parallel_mpi_utilities LIBRARIES libpurify)
 endif()
+
+install(DIRECTORY ${CMAKE_SOURCE_DIR}/data DESTINATION .)
+

=== debian/changelog ===
purify (4.2.0-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Aug 2025 08:19:32 +0200

purify (4.2.0-1) unstable; urgency=medium

  * New upstream version 4.2.0
  * Drop Add-missing-cstdint-header.patch: applied upstream
  * Replace catch b-dep with catch2 (Closes: #1092262)
  * Disable failing tests
  * Push Standards-Version to 4.7.2, no changes needed
  * Don't install test data

 -- Ole Streicher <olebole@debian.org>  Wed, 26 Mar 2025 22:15:47 +0100

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Gijs Molenaar <gijs@pythonic.nl>, Ole Streicher <olebole@debian.org>
 Build-Depends: architecture-is-64-bit,
                casacore-dev,
-               catch,
+               catch2,
                cmake,
                debhelper-compat (= 13),
                libblas-dev,
@@ -19,7 +19,7 @@
                libspdlog-dev,
                libtiff5-dev,
                libyaml-cpp-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/debian-astro-team/purify.git
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/purify
 Homepage: https://astro-informatics.github.io/purify/

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/purify-$1\.tar\.gz/ \
  https://github.com/astro-informatics/purify/tags .*/v?(\d\S*)\.tar\.gz
